package com.fp.persistence.pgeneral.batch;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import java.sql.Timestamp;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENEBATCHLOGPREVIOUSPROCESS*/
@Entity(name="TgeneBatchLogPreviousProcess")
@Table(name="TGENEBATCHLOGPREVIOUSPROCESS")
public class TgeneBatchLogPreviousProcess extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneBatchLogPreviousProcess
*/
@EmbeddedId
private TgeneBatchLogPreviousProcessKey pk;
@Column(name="TRANSACTIONMODULE", nullable=false)

/**
* Modulo al que pertence la transaccion
*/
private String transactionmodule;

@Column(name="TRANSACTIONCODE", nullable=false)

/**
* Codigo de transaccion dentro del modulo
*/
private Integer transactioncode;

@Column(name="TRANSACTIONVERSION", nullable=false)

/**
* Version de transaccion
*/
private Integer transactionversion;

@Column(name="RESULTCODE", nullable=true)

/**
* Codigo de resultado de la insersión de las cuentas
*/
private String resultcode;

@Column(name="USERMESSAGE", nullable=true)

/**
* Mensaje tecnico, se llena si la transaccion tiene un resultado diferente de ok. 
*/
private String usermessage;

/**Contructor por defecto*/
public TgeneBatchLogPreviousProcess(){
}
/**Contructor de TgeneBatchLogPreviousProcess
@param pPk Clave Primaria del entity
@param pTransactionmodule Modulo al que pertence la transaccion
@param pTransactioncode Codigo de transaccion dentro del modulo
@param pTransactionversion Version de transaccion
*/
public TgeneBatchLogPreviousProcess(TgeneBatchLogPreviousProcessKey pPk,String pTransactionmodule,Integer pTransactioncode,Integer pTransactionversion){
 this();
 pk=pPk;
 transactionmodule=pTransactionmodule;
 transactioncode=pTransactioncode;
 transactionversion=pTransactionversion;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneBatchLogPreviousProcess
*/
public static TgeneBatchLogPreviousProcess find(EntityManager pEntityManager,TgeneBatchLogPreviousProcessKey pKey) throws Exception{
    TgeneBatchLogPreviousProcess obj = pEntityManager.find(TgeneBatchLogPreviousProcess.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneBatchLogPreviousProcess
@return El objeto que referencia a la Clave primaria de TgeneBatchLogPreviousProcess
*/
public TgeneBatchLogPreviousProcessKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneBatchLogPreviousProcess
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneBatchLogPreviousProcess
*/
public void setPk(TgeneBatchLogPreviousProcessKey pPk){
  pk=pPk;
}
/**Obtiene el valor de transactionmodule
@return valor de transactionmodule*/
public String getTransactionmodule(){
  return transactionmodule;
}
/**Fija el valor de transactionmodule
@param pTransactionmodule nuevo Valor de transactionmodule*/
public void setTransactionmodule(String pTransactionmodule){
  transactionmodule=pTransactionmodule;
}

/**Obtiene el valor de transactioncode
@return valor de transactioncode*/
public Integer getTransactioncode(){
  return transactioncode;
}
/**Fija el valor de transactioncode
@param pTransactioncode nuevo Valor de transactioncode*/
public void setTransactioncode(Integer pTransactioncode){
  transactioncode=pTransactioncode;
}

/**Obtiene el valor de transactionversion
@return valor de transactionversion*/
public Integer getTransactionversion(){
  return transactionversion;
}
/**Fija el valor de transactionversion
@param pTransactionversion nuevo Valor de transactionversion*/
public void setTransactionversion(Integer pTransactionversion){
  transactionversion=pTransactionversion;
}

/**Obtiene el valor de resultcode
@return valor de resultcode*/
public String getResultcode(){
  return resultcode;
}
/**Fija el valor de resultcode
@param pResultcode nuevo Valor de resultcode*/
public void setResultcode(String pResultcode){
  resultcode=pResultcode;
}

/**Obtiene el valor de usermessage
@return valor de usermessage*/
public String getUsermessage(){
  return usermessage;
}
/**Fija el valor de usermessage
@param pUsermessage nuevo Valor de usermessage*/
public void setUsermessage(String pUsermessage){
  usermessage=pUsermessage;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneBatchLogPreviousProcess))return false;
    TgeneBatchLogPreviousProcess that = (TgeneBatchLogPreviousProcess) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad TgeneBatchLogPreviousProcess
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco TgeneBatchLogPreviousProcess
*/
public Object createInstance(){
 TgeneBatchLogPreviousProcess instance=new TgeneBatchLogPreviousProcess();	
 instance.setPk(new TgeneBatchLogPreviousProcessKey());
 return instance;
}
/**Clona la entidad TgeneBatchLogPreviousProcess
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneBatchLogPreviousProcess p=(TgeneBatchLogPreviousProcess)this.clone();
  p.setPk((TgeneBatchLogPreviousProcessKey)this.pk.cloneMe());
  return p;
}
}
